package com.googlecode.marrowboy;

import org.hamcrest.Description;
import org.hamcrest.Matcher;
import org.hamcrest.StringDescription;

public class ProxyAssert {

	/**
	 * This method copied directly from the hamcrest 1.1 distribution. We use
	 * this in case the real MatcherAssert has been blatted by bytecode
	 * manipulation.
	 */
	public static <T> void assertThat(T actual, Matcher<T> matcher) {
		assertThat("", actual, matcher);
	}

	/**
	 * This method copied directly from the hamcrest 1.1 distribution. We use
	 * this in case the real MatcherAssert has been blatted by bytecode
	 * manipulation.
	 */
	public static <T> void assertThat(String reason, T actual, Matcher<? super T> matcher) {

		if (!matcher.matches(actual)) {
			Description description = new StringDescription();
			description.appendText(reason)
						.appendText("\nExpected: ")
						.appendDescriptionOf(matcher)
						.appendText("\n     got: ")
						.appendValue(actual)
						.appendText("\n");

			throw new java.lang.AssertionError(description.toString());
		}
	}

}
