package com.googlecode.marrowboy.writers;

/**
 * Interface for classes which provide Cascading StyleSheet (CSS) data.
 * 
 * @author mjg
 */
public interface CssProvider {

	/**
	 * Get the CSS - implementations can get it from a file or wherever.
	 * 
	 * @return CSS code suitable for inserting into the &lt;head&gt; section of
	 *         an HTML page.
	 */
	String getCss();

}
